package java.text;

final class CharacterBreakData extends TextBoundaryData {
   private static final byte accent_diacritic = 0;
   private static final byte baseForm = 1;
   private static final int COL_COUNT = 2;
   // $FF: renamed from: SI byte
   private static final byte field_0 = -128;
   private static final byte[] kCharacterForwardData = new byte[]{0, 0, -126, -126, -126, -128};
   private static final WordBreakTable kCharacterForwardTable;
   private static final byte[] kCharacterBackwardData;
   private static final WordBreakTable kCharacterBackwardTable;
   private static final int[] kRawMapping;
   private static final SpecialMapping[] kExceptionChar;
   private static final UnicodeClassMapping kCharacterMap;

   public WordBreakTable forward() {
      return kCharacterForwardTable;
   }

   public WordBreakTable backward() {
      return kCharacterBackwardTable;
   }

   public UnicodeClassMapping map() {
      return kCharacterMap;
   }

   static {
      kCharacterForwardTable = new WordBreakTable(2, kCharacterForwardData);
      kCharacterBackwardData = new byte[]{0, 0, -127, -128};
      kCharacterBackwardTable = new WordBreakTable(2, kCharacterBackwardData);
      kRawMapping = new int[]{1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
      kExceptionChar = new SpecialMapping[0];
      kCharacterMap = new UnicodeClassMapping(kRawMapping, kExceptionChar);
   }
}
