package java.text;

import java.io.Serializable;
import java.util.Locale;
import java.util.ResourceBundle;

public final class DecimalFormatSymbols implements Cloneable, Serializable {
   private char zeroDigit;
   private char groupingSeparator;
   private char decimalSeparator;
   private char perMill;
   private char percent;
   private char digit;
   private char patternSeparator;
   private String infinity;
   private String NaN;
   private char minusSign;
   private String currencySymbol;
   private String intlCurrencySymbol;

   public DecimalFormatSymbols() {
      this.initialize(Locale.getDefault());
   }

   public DecimalFormatSymbols(Locale var1) {
      this.initialize(var1);
   }

   public char getZeroDigit() {
      return this.zeroDigit;
   }

   public void setZeroDigit(char var1) {
      this.zeroDigit = var1;
   }

   public char getGroupingSeparator() {
      return this.groupingSeparator;
   }

   public void setGroupingSeparator(char var1) {
      this.groupingSeparator = var1;
   }

   public char getDecimalSeparator() {
      return this.decimalSeparator;
   }

   public void setDecimalSeparator(char var1) {
      this.decimalSeparator = var1;
   }

   public char getPerMill() {
      return this.perMill;
   }

   public void setPerMill(char var1) {
      this.perMill = var1;
   }

   public char getPercent() {
      return this.percent;
   }

   public void setPercent(char var1) {
      this.percent = var1;
   }

   public char getDigit() {
      return this.digit;
   }

   public void setDigit(char var1) {
      this.digit = var1;
   }

   public char getPatternSeparator() {
      return this.patternSeparator;
   }

   public void setPatternSeparator(char var1) {
      this.patternSeparator = var1;
   }

   public String getInfinity() {
      return this.infinity;
   }

   public void setInfinity(String var1) {
      this.infinity = var1;
   }

   public String getNaN() {
      return this.NaN;
   }

   public void setNaN(String var1) {
      this.NaN = var1;
   }

   public char getMinusSign() {
      return this.minusSign;
   }

   public void setMinusSign(char var1) {
      this.minusSign = var1;
   }

   public Object clone() {
      try {
         return (DecimalFormatSymbols)super.clone();
      } catch (CloneNotSupportedException var1) {
         throw new InternalError();
      }
   }

   public boolean equals(Object var1) {
      if (this == var1) {
         return true;
      } else if (this.getClass() != var1.getClass()) {
         return false;
      } else {
         DecimalFormatSymbols var2 = (DecimalFormatSymbols)var1;
         return this.zeroDigit == var2.zeroDigit && this.groupingSeparator == var2.groupingSeparator && this.decimalSeparator == var2.decimalSeparator && this.percent == var2.percent && this.perMill == var2.perMill && this.digit == var2.digit && this.minusSign == var2.minusSign && this.patternSeparator == var2.patternSeparator && this.infinity.equals(var2.infinity) && this.NaN.equals(var2.NaN) && this.currencySymbol.equals(var2.currencySymbol) && this.intlCurrencySymbol.equals(var2.intlCurrencySymbol);
      }
   }

   public int hashCode() {
      int var1 = this.zeroDigit;
      var1 = var1 * 37 + this.groupingSeparator;
      var1 = var1 * 37 + this.decimalSeparator;
      return var1;
   }

   private void initialize(Locale var1) {
      ResourceBundle var2 = ResourceBundle.getBundle("java.text.resources.LocaleElements", var1);
      String[] var3 = var2.getStringArray("NumberElements");
      this.decimalSeparator = var3[0].charAt(0);
      this.groupingSeparator = var3[1].charAt(0);
      this.patternSeparator = ';';
      this.percent = var3[3].charAt(0);
      this.zeroDigit = var3[4].charAt(0);
      this.digit = var3[5].charAt(0);
      this.minusSign = var3[6].charAt(0);
      String[] var4 = var2.getStringArray("CurrencyElements");
      this.currencySymbol = var4[0];
      this.intlCurrencySymbol = var4[1];
      this.perMill = 8240;
      this.infinity = "∞";
      this.NaN = "�";
   }
}
