package java.text;

final class SentenceBreakData extends TextBoundaryData {
   private static final byte other = 0;
   private static final byte space = 1;
   private static final byte terminator = 2;
   private static final byte ambiguosTerm = 3;
   private static final byte openBracket = 4;
   private static final byte closeBracket = 5;
   private static final byte cjk = 6;
   private static final byte paragraphBreak = 7;
   private static final byte lowerCase = 8;
   private static final byte upperCase = 9;
   private static final byte number = 10;
   private static final int COL_COUNT_BACKWARD = 11;
   private static final byte quote = 11;
   private static final int COL_COUNT_FORWARD = 12;
   // $FF: renamed from: SI byte
   private static final byte field_0 = -128;
   private static final byte[] kSentenceForwardData = new byte[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -127, -127, -126, -123, -127, -127, -127, -124, -127, -120, -119, -127, -128, -125, -126, -123, -127, -126, -128, -124, -128, -128, -128, -126, -128, -125, -128, -128, -128, -128, -128, -124, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -122, -126, -123, -127, -123, -128, -124, -127, -128, -128, -123, -128, -122, -128, -128, -121, -127, -128, -124, -127, -128, -127, -128, -128, -128, -128, -128, 7, -128, -128, -128, -127, 0, -128, -128, -127, -127, -126, -120, -127, -123, -128, -124, -127, -120, -119, -123, -127, -127, -126, -119, -127, -123, -128, -124, -127, -127, -119, -123};
   private static final WordBreakTable kSentenceForward;
   private static final byte[] kSentenceBackwardData;
   private static final WordBreakTable kSentenceBackward;
   private static final int[] kRawMapping;
   private static SpecialMapping[] kExceptionChar;
   private static final UnicodeClassMapping kSentenceMap;

   public WordBreakTable forward() {
      return kSentenceForward;
   }

   public WordBreakTable backward() {
      return kSentenceBackward;
   }

   public UnicodeClassMapping map() {
      return kSentenceMap;
   }

   static {
      kSentenceForward = new WordBreakTable(12, kSentenceForwardData);
      kSentenceBackwardData = new byte[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -127, -127, -127, -127, -127, -127, -124, -127, -126, -127, -127, -127, -125, -128, -126, -125, -125, -124, -128, -126, -127, -127, -127, -125, -128, -126, -125, -125, -124, -128, -126, -127, -127, -124, -125, -128, -124, -124, -124, -124, -128, -126, -124, -124};
      kSentenceBackward = new WordBreakTable(11, kSentenceBackwardData);
      kRawMapping = new int[]{0, 9, 8, 0, 0, 0, 0, 0, 0, 10, 10, 10, 1, 1, 1, 0, 0, 0, 0, 0, 0, 4, 5, 0, 0, 0, 0, 0, 0};
      kExceptionChar = new SpecialMapping[]{new SpecialMapping('\t', 1), new SpecialMapping('\n', 1), new SpecialMapping('\f', 2), new SpecialMapping('!', 2), new SpecialMapping('"', 11), new SpecialMapping('\'', 11), new SpecialMapping('.', 3), new SpecialMapping('?', 2), new SpecialMapping(' ', 0), new SpecialMapping('\u2029', 7), new SpecialMapping('。', 2), new SpecialMapping('ぁ', 'ゔ', 6), new SpecialMapping('゙', '゜', 6), new SpecialMapping('ァ', 'ヶ', 6), new SpecialMapping('一', '龥', 6), new SpecialMapping('豈', '鶴', 6), new SpecialMapping('\ufeff', 0)};
      kSentenceMap = new UnicodeClassMapping(kRawMapping, kExceptionChar);
   }
}
