package java.text;

abstract class TextBoundaryData {
   protected static final char ASCII_END_OF_TEXT = '\u0003';
   protected static final char ASCII_HORIZONTAL_TABULATION = '\t';
   protected static final char ASCII_LINEFEED = '\n';
   protected static final char ASCII_VERTICAL_TABULATION = '\u000b';
   protected static final char ASCII_FORM_FEED = '\f';
   protected static final char ASCII_CARRIAGE_RETURN = '\r';
   protected static final char ASCII_SPACE = ' ';
   protected static final char ASCII_EXCLAMATION_MARK = '!';
   protected static final char ASCII_QUOTATION_MARK = '"';
   protected static final char ASCII_NUMBER_SIGN = '#';
   protected static final char ASCII_PERCENT = '%';
   protected static final char ASCII_AMPERSAND = '&';
   protected static final char ASCII_APOSTROPHE = '\'';
   protected static final char ASCII_COMMA = ',';
   protected static final char ASCII_FULL_STOP = '.';
   protected static final char ASCII_COLON = ':';
   protected static final char ASCII_SEMICOLON = ';';
   protected static final char ASCII_QUESTION_MARK = '?';
   protected static final char ASCII_NONBREAKING_SPACE = ' ';
   protected static final char ASCII_CENT_SIGN = '¢';
   protected static final char LATIN1_SOFTHYPHEN = '\u00ad';
   protected static final char ARABIC_PERCENT_SIGN = '٪';
   protected static final char ARABIC_DECIMAL_SEPARATOR = '٫';
   protected static final char PUNCTUATION_HYPHENATION_POINT = '‧';
   protected static final char PUNCTUATION_LINE_SEPARATOR = '\u2028';
   protected static final char PUNCTUATION_PARAGRAPH_SEPARATOR = '\u2029';
   protected static final char PER_MILLE_SIGN = '‰';
   protected static final char PER_TEN_THOUSAND_SIGN = '‱';
   protected static final char PUNCTUATION_IDEOGRAPHIC_FULL_STOP = '。';
   protected static final char HIRAGANA_LETTER_SMALL_A = 'ぁ';
   protected static final char HIRAGANA_LETTER_VU = 'ゔ';
   protected static final char COMBINING_KATAKANA_HIRAGANA_VOICED_SOUND_MARK = '゙';
   protected static final char HIRAGANA_SEMIVOICED_SOUND_MARK = '゜';
   protected static final char KATAKANA_LETTER_SMALL_A = 'ァ';
   protected static final char KATAKANA_LETTER_SMALL_KE = 'ヶ';
   protected static final char UNICODE_LOW_BOUND_HAN = '一';
   protected static final char UNICODE_HIGH_BOUND_HAN = '龥';
   protected static final char HANGUL_SYL_LOW = '가';
   protected static final char HANGUL_SYL_HIGH = '힣';
   protected static final char CJK_COMPATIBILITY_F900 = '豈';
   protected static final char CJK_COMPATIBILITY_FA2D = '鶴';
   protected static final char UNICODE_ZERO_WIDTH_NON_BREAKING_SPACE = '\ufeff';

   public abstract WordBreakTable forward();

   public abstract WordBreakTable backward();

   public abstract UnicodeClassMapping map();
}
