package java.text;

final class UnicodeClassMapping {
   private int[] mappedValue;
   private SpecialMapping[] exceptionChars;

   public UnicodeClassMapping(int[] var1, SpecialMapping[] var2) {
      this.mappedValue = var1;
      this.exceptionChars = var2;
   }

   public int mappedChar(char var1) {
      if (this.exceptionChars.length != 0 && (var1 <= '?' || var1 >= 160)) {
         int var2 = 0;
         int var3 = this.exceptionChars.length;

         int var4;
         while(var3 - (var4 = (var3 - var2 >> 1) + var2) > 1) {
            if (var1 > this.exceptionChars[var4].endChar) {
               var2 = var4 + 1;
            } else {
               var3 = var4;
            }
         }

         SpecialMapping var5 = this.exceptionChars[var2];
         if (var5.startChar <= var1 && var1 <= var5.endChar) {
            return var5.newValue;
         } else if (var3 < this.exceptionChars.length) {
            var5 = this.exceptionChars[var3];
            if (var5.startChar <= var1 && var1 <= var5.endChar) {
               return var5.newValue;
            } else {
               return this.mappedValue[Character.getType(var1)];
            }
         } else {
            return this.mappedValue[Character.getType(var1)];
         }
      } else {
         return this.mappedValue[Character.getType(var1)];
      }
   }
}
