package java.text;

final class Utility {
   static final boolean arrayEquals(Object[] var0, Object var1) {
      if (var0 == null) {
         return var1 == null;
      } else if (!(var1 instanceof Object[])) {
         return false;
      } else {
         Object[] var2 = var1;
         return var0.length == var2.length && arrayRegionMatches((Object[])var0, 0, (Object[])var2, 0, var0.length);
      }
   }

   static final boolean arrayEquals(int[] var0, Object var1) {
      if (var0 == null) {
         return var1 == null;
      } else if (!(var1 instanceof int[])) {
         return false;
      } else {
         int[] var2 = (int[])var1;
         return var0.length == var2.length && arrayRegionMatches((int[])var0, 0, (int[])var2, 0, var0.length);
      }
   }

   static final boolean arrayEquals(double[] var0, Object var1) {
      if (var0 == null) {
         return var1 == null;
      } else if (!(var1 instanceof double[])) {
         return false;
      } else {
         double[] var2 = (double[])var1;
         return var0.length == var2.length && arrayRegionMatches((double[])var0, 0, (double[])var2, 0, var0.length);
      }
   }

   static final boolean arrayEquals(Object var0, Object var1) {
      if (var0 == null) {
         return var1 == null;
      } else if (var0 instanceof Object[]) {
         return arrayEquals(var0, var1);
      } else if (var0 instanceof int[]) {
         return arrayEquals((int[])var0, var1);
      } else {
         return var0 instanceof double[] ? arrayEquals((int[])var0, var1) : var0.equals(var1);
      }
   }

   static final boolean arrayRegionMatches(Object[] var0, int var1, Object[] var2, int var3, int var4) {
      int var5 = var1 + var4;
      int var6 = var3 - var1;

      for(int var7 = var1; var7 < var5; ++var7) {
         if (!arrayEquals(var0[var7], var2[var7 + var6])) {
            return false;
         }
      }

      return true;
   }

   static final boolean arrayRegionMatches(int[] var0, int var1, int[] var2, int var3, int var4) {
      int var5 = var1 + var4;
      int var6 = var3 - var1;

      for(int var7 = var1; var7 < var5; ++var7) {
         if (var0[var7] != var2[var7 + var6]) {
            return false;
         }
      }

      return true;
   }

   static final boolean arrayRegionMatches(double[] var0, int var1, double[] var2, int var3, int var4) {
      int var5 = var1 + var4;
      int var6 = var3 - var1;

      for(int var7 = var1; var7 < var5; ++var7) {
         if (var0[var7] != var2[var7 + var6]) {
            return false;
         }
      }

      return true;
   }

   static final boolean objectEquals(Object var0, Object var1) {
      if (var0 == null) {
         return var1 == null;
      } else {
         return arrayEquals(var0, var1);
      }
   }
}
