package java.text;

final class WordBreakTable {
   static final byte MARK_MASK = -128;
   static final byte INDEX_MASK = 127;
   private static final int INITIAL_STATE = 1;
   private static final int END_STATE = 0;
   private byte[] data;
   private int cols;

   public WordBreakTable(int var1, byte[] var2) {
      this.data = var2;
      this.cols = var1;
   }

   public int get(int var1, int var2) {
      return this.data[(var1 & 127) * this.cols + var2];
   }

   public boolean isMarkState(int var1) {
      return (var1 & -128) != 0;
   }

   public boolean isEndState(int var1) {
      return (var1 & 127) == 0;
   }

   public int initialState() {
      return 1;
   }
}
