package java.text.resources;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Locale;
import java.util.ResourceBundle;

public class LocaleData extends ResourceBundle {
   private Hashtable localeKeys;
   private static String[] keys = new String[]{"LocaleString", "LocaleID", "ShortLanguage", "ShortCountry", "Languages", "Countries", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthNames", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "MonthAbbreviations", "DayNames", "DayNames", "DayNames", "DayNames", "DayNames", "DayNames", "DayNames", "DayAbbreviations", "DayAbbreviations", "DayAbbreviations", "DayAbbreviations", "DayAbbreviations", "DayAbbreviations", "DayAbbreviations", "AmPmMarkers", "AmPmMarkers", "Eras", "NumberPatterns", "NumberPatterns", "NumberPatterns", "NumberElements", "NumberElements", "NumberElements", "NumberElements", "NumberElements", "NumberElements", "NumberElements", "NumberElements", "CurrencyElements", "CurrencyElements", "CurrencyElements", "DateTimePatterns", "DateTimePatterns", "DateTimePatterns", "DateTimePatterns", "DateTimePatterns", "DateTimePatterns", "DateTimePatterns", "DateTimePatterns", "DateTimePatterns", "DateTimeElements", "DateTimeElements", "CollationElements"};
   private static Locale[] localeList = new Locale[]{new Locale("ar", "", ""), new Locale("be", "", ""), new Locale("bg", "", ""), new Locale("ca", "", ""), new Locale("cs", "", ""), new Locale("da", "", ""), new Locale("de", "", ""), new Locale("de", "AT", ""), new Locale("de", "CH", ""), new Locale("el", "", ""), new Locale("en", "CA", ""), new Locale("en", "GB", ""), new Locale("en", "IE", ""), new Locale("en", "US", ""), new Locale("es", "", ""), new Locale("et", "", ""), new Locale("fi", "", ""), new Locale("fr", "", ""), new Locale("fr", "BE", ""), new Locale("fr", "CA", ""), new Locale("fr", "CH", ""), new Locale("hr", "", ""), new Locale("hu", "", ""), new Locale("is", "", ""), new Locale("it", "", ""), new Locale("it", "CH", ""), new Locale("iw", "", ""), new Locale("ja", "", ""), new Locale("ko", "", ""), new Locale("lt", "", ""), new Locale("lv", "", ""), new Locale("mk", "", ""), new Locale("nl", "", ""), new Locale("nl", "BE", ""), new Locale("no", "", ""), new Locale("no", "NO", "NY"), new Locale("pl", "", ""), new Locale("pt", "", ""), new Locale("ro", "", ""), new Locale("ru", "", ""), new Locale("sh", "", ""), new Locale("sk", "", ""), new Locale("sl", "", ""), new Locale("sq", "", ""), new Locale("sr", "", ""), new Locale("sv", "", ""), new Locale("tr", "", ""), new Locale("uk", "", ""), new Locale("zh", "", ""), new Locale("zh", "TW", "")};

   public Object handleGetObject(String var1) {
      return this.localeKeys.get(var1);
   }

   public static Locale[] getAvailableLocales(String var0) {
      return localeList;
   }

   public Enumeration getKeys() {
      return this.localeKeys.keys();
   }

   protected void init(String[] var1) {
      if (var1.length != keys.length) {
         System.out.println("Data length (" + var1.length + ") != key length (" + keys.length + ")");
         throw new ArrayIndexOutOfBoundsException();
      } else {
         this.localeKeys = new Hashtable();
         int var2 = 0;

         int var3;
         for(var3 = 1; var3 < var1.length; ++var3) {
            if (!keys[var3].equals(keys[var2])) {
               this.storeStrings(var1, var2, var3 - 1);
               var2 = var3;
            }
         }

         this.storeStrings(var1, var2, var3 - 1);
      }
   }

   private static String[] split(String var0, char var1) {
      String[] var2 = new String[200];
      int var3 = 0;

      int var4;
      for(var4 = 0; var3 < var0.length(); ++var4) {
         int var5 = var0.indexOf(var1, var3);
         if (var5 == -1) {
            var5 = var0.length();
         }

         var2[var4] = var0.substring(var3, var5);
         var3 = var5 + 1;
      }

      String[] var6 = new String[var4];
      System.arraycopy(var2, 0, var6, 0, var4);
      return var6;
   }

   private void storeStrings(String[] var1, int var2, int var3) {
      if (!keys[var2].equals("Eras") && !keys[var2].equals("Languages") && !keys[var2].equals("Countries")) {
         if (var2 == var3) {
            this.localeKeys.put(keys[var2], var1[var2]);
         } else {
            String[] var8 = new String[var3 - var2 + 1];
            System.arraycopy(var1, var2, var8, 0, var3 - var2 + 1);
            this.localeKeys.put(keys[var2], var8);
         }
      } else {
         String[] var4 = split(var1[var2], ';');

         for(int var5 = 0; var5 < var4.length; ++var5) {
            var4[var5] = var4[var5].trim();
         }

         if (keys[var2].equals("Eras")) {
            this.localeKeys.put(keys[var2], var4);
         } else {
            String[][] var6 = new String[var4.length][2];

            for(int var7 = 0; var7 < var4.length; ++var7) {
               var6[var7] = split(var4[var7], '_');
            }

            this.localeKeys.put(keys[var2], var6);
         }
      }
   }
}
